<?php
/*******************************************************************
 *			
 * 			Fichier			:	engine_send.php 
 * 			Cr le			:	20 juin 2003 
 * 			Dernire modif	:	01 juillet 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('IN_NEWSLETTER') )
{
	exit('<b>No hacking</b>'); 
}

/*
 * launch_sending()
 * 
 * Cette fonction est appelle soit dans envoi.php lors de l'envoi, soit 
 * dans le fichier appell originellement cron.php 
 * 
 * @param array $listdata	: Tableau des donnes de la liste concerne
 * @param array $logdata	: Tableau des donnes de la newsletter
 * 
 * @access private
 * 
 * @return void
 */
function launch_sending($listdata, $logdata)
{
	global $waroot, $nl_config, $db, $dbhost, $dbuser, $dbpassword, $dbname, $lang, $mailer; 
	
	//
	// On traite les donnes de la newsletter  envoyer
	//
	$mailer->set_subject(stripslashes($logdata['log_subject'])); 
	
	$body 	 = array(
		FORMAT_TEXTE => stripslashes($logdata['log_body_text']),
		FORMAT_HTML  => stripslashes($logdata['log_body_html'])
	); 
	
	//
	// Ajout du lien de dsinscription, selon les mthodes d'envoi/format utiliss
	//
	if( $listdata['use_cron'] )
	{
		$liste_email = ( !empty($listdata['liste_alias']) ) ? $listdata['liste_alias'] : $listdata['sender_email']; 
		
		if( $listdata['liste_format'] != FORMAT_HTML )
		{
			$body[FORMAT_TEXTE] = str_replace('{LINKS}', $liste_email, $body[FORMAT_TEXTE]); 
		}
		
		if( $listdata['liste_format'] != FORMAT_TEXTE )
		{
			$body[FORMAT_HTML] = str_replace('{LINKS}', '<a href="mailto:' . $liste_email . '?subject=unsubscribe">' . $liste_email . '</a>', $body[FORMAT_HTML]);
		}
	}
	else
	{
		if( $nl_config['engine_send'] == ENGINE_BCC )
		{
			if( $listdata['liste_format'] != FORMAT_HTML )
			{
				$body[FORMAT_TEXTE] = str_replace('{LINKS}', $listdata['form_url'], $body[FORMAT_TEXTE]); 
			}
			
			if( $listdata['liste_format'] != FORMAT_TEXTE )
			{
				$body[FORMAT_HTML] = str_replace('{LINKS}', '<a href="' . $listdata['form_url'] . '">' . $listdata['form_url'] . '</a>', $body[FORMAT_HTML]);
			}
		}
		else
		{
			$tmp_link  = $listdata['form_url'] . ( ( strstr($listdata['form_url'], '?') ) ? '&' : '?' ); 
			$tmp_link .= 'action=desinscription&email={EMAIL}&code={CODE}&liste=' . $listdata['liste_id']; 
			
			$link = array(
				FORMAT_TEXTE => $tmp_link,
				FORMAT_HTML  => '<a href="' . $tmp_link . '">' . $tmp_link . '</a>'
			); 
			
			unset($tmp_link); 
		}
	}
	
	//
	// On s'occupe maintenant des fichiers joints ou incorpors 
	// Si les fichiers sont stocks sur un serveur ftp, on les rapatrie le temps du flot d'envoi
	//
	$total_files = count($logdata['joined_files']); 
	$tmp_files   = array(); 
	
	if( $nl_config['use_ftp'] )
	{
		include($waroot . 'includes/class.attach.php'); 
		
		$attach = new Attach(); 
	}
	
	preg_match_all('/<.+?"cid:([^\\:*\/?<">|]+)"[^>]*>/i', $body[FORMAT_HTML], $matches); 
	
	for( $i = 0; $i < $total_files; $i++ )
	{
		if( $nl_config['use_ftp'] )
		{
			$file_path   = $attach->ftp_to_tmp($logdata['joined_files'][$i]); 
			$tmp_files[] = $file_path; 
		}
		else
		{
			$file_path = $waroot . $nl_config['upload_path'] . $logdata['joined_files'][$i]['file_physical_name']; 
		}
		
		$mailer->attachment(
			$file_path,
			$logdata['joined_files'][$i]['file_real_name'],
			'attachment',
			$logdata['joined_files'][$i]['file_mimetype'],
			( in_array($logdata['joined_files'][$i]['file_real_name'], $matches[1]) ) ? true : false
		); 
	}
	
	//
	// On rcupre les infos sur les abonns destinataires
	//
	$sql = "SELECT a.abo_id, a.abo_pseudo, a.abo_email, a.abo_register_key, al.format 
		FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
		WHERE al.liste_id = " . $listdata['liste_id'] . " 
			AND a.abo_id = al.abo_id 
			AND al.send = 0 
			AND a.abo_status = " . ABO_ACTIF; 
	if( !($result = $db->query($sql, 0, $nl_config['emails_sended'])) )
	{
		trigger_error('Impossible d\'obtenir la liste des adresses emails', ERROR); 
	}
	
	if( $row = $db->fetch_array($result) )
	{
		fake_header(false); 
		
		$abo_id_ary	= array(); 
		$format		= ( $listdata['liste_format'] != FORMAT_MULTIPLE ) ? $listdata['liste_format'] : false; 
		
		if( $nl_config['engine_send'] == ENGINE_BCC )
		{
			$abonnes = array(FORMAT_TEXTE => array(), FORMAT_HTML => array()); 
			
			do
			{
				$abo_id_ary[] = $row['abo_id']; 
				$abo_format   = ( !$format ) ? $row['format'] : $format; 
				
				$abonnes[$abo_format][] = $row['abo_email']; 
				
				fake_header(true); 
			}
			while( $row = $db->fetch_array($result) ); 
			
			foreach( $abonnes AS $format => $emails_ary )
			{
				if( count($emails_ary) )
				{
					$mailer->clear_address(); 
					$mailer->set_address($emails_ary, 'bcc'); 
					$mailer->set_format($format); 
					$mailer->set_message($body[$format]); 
					
					if( !$mailer->send() )
					{
						trigger_error(sprintf($lang['Message']['Failed_sending2'], htmlspecialchars($mailer->msg_error)), ERROR); 
					}
				}
			}
		}
		else if( $nl_config['engine_send'] == ENGINE_UNIQ )
		{
			do
			{
				$abo_format = ( !$format ) ? $row['format'] : $format; 
				$body_tmp   = $body[$abo_format]; 
				$link_tmp   = $link[$abo_format]; 
				
				$mailer->clear_address(); 
				$mailer->set_address($row['abo_email'], $row['abo_pseudo']); 
				$mailer->set_format($abo_format); 
				
				if( $listdata['return_email'] != '' )
				{
					$mailer->set_return_path($listdata['return_email']); 
				}
				
				if( empty($mailer->compiled_message[$abo_format]) )
				{
					if( !$listdata['use_cron'] )
					{
						$body_tmp = str_replace('{LINKS}', $link_tmp, $body_tmp); 
					}
					
					$mailer->set_message($body_tmp); 
				}
				
				$mailer->assign_tags(array(
					'NAME'  => ( $row['abo_pseudo'] != '' ) ? unhtmlspecialchars($row['abo_pseudo']) : $row['abo_email']
				)); 
				
				if( !$listdata['use_cron'] )
				{
					$mailer->assign_tags(array(
						'CODE'  => $row['abo_register_key'],
						'EMAIL' => $row['abo_email']
					)); 
				}
				
				if( $mailer->send() )
				{
					$abo_id_ary[] = $row['abo_id']; 
				}
				
				fake_header(true); 
			}
			while( $row = $db->fetch_array($result) ); 
			
			//
			// Aucun email envoy, il y a manifestement un problme, on affiche le message d'erreur
			//
			if( count($abo_id_ary) == 0 )
			{
				trigger_error(sprintf($lang['Message']['Failed_sending2'], htmlspecialchars($mailer->msg_error)), ERROR); 
			}
		}
		else
		{
			trigger_error('Unknown_engine', ERROR); 
		}
		
		$db->free_result($result); 
	}
	else
	{
		trigger_error('No_subscribers', MESSAGE); 
	}
	
	//
	// Si l'option FTP est utilise, suppression des fichiers temporairement crs
	//
	if( $nl_config['use_ftp'] )
	{
		foreach( $tmp_files AS $filename )
		{
			$attach->remove_file($filename); 
		}
	}
	unset($tmp_files); 
	
	$no_send = $sended = 0; 
	
	if( $nl_config['emails_sended'] > 0 )
	{
		$sql = "UPDATE " . ABO_LISTE_TABLE . " 
			SET send = 1 
			WHERE abo_id IN(" . implode(', ', $abo_id_ary) . ") 
				AND liste_id = " . $listdata['liste_id']; 
		if( !$db->query($sql) )
		{
			//
			// L'envoi a dur trop longtemps et la connexion au serveur SQL a t perdue
			// On initialise une nouvelle connexion
			//
			unset($db); 
			
			$db = new sql($dbhost, $dbuser, $dbpassword, $dbname); 
			if( !$db->connect_id || !$db->query($sql) )
			{
				trigger_error('Impossible de mettre  jour la table des abonns (connexion au serveur sql perdue)', ERROR); 
			}
		}
		
		$sql = "SELECT COUNT(*) AS num_dest, al.send 
			FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
			WHERE al.liste_id = " . $listdata['liste_id'] . " 
				AND a.abo_id = al.abo_id 
				AND a.abo_status = " . ABO_ACTIF . " 
			GROUP BY al.send"; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir le nombre d\'envois restants  faire', ERROR); 
		}
		
		while( $row = $db->fetch_array($result) )
		{
			if( $row['send'] == 1 )
			{
				$sended = $row['num_dest']; 
			}
			else
			{
				$no_send = $row['num_dest']; 
			}
		}
		$db->free_result($result); 
	}
	else
	{
		$sended = count($abo_id_ary); 
	}
	
	if( $no_send > 0 )
	{
		$message = sprintf($lang['Message']['Success_send'], $nl_config['emails_sended']); 
		
		if( !defined('IN_CRON') )
		{
			$step = ( !empty($_GET['step']) ) ? $_GET['step'] : ''; 
			
			if( $step == 'auto' )
			{
				Location(sessid('./envoi.php?resend=true&id=' . $logdata['log_id'] . '&step=auto')); 
			}
			
			$message .= '<br /><br />' .  sprintf($lang['Click_resend_auto'], '<a href="' . sessid('envoi.php?resend=true&amp;id=' . $logdata['log_id'] . '&amp;step=auto') . '">', '</a>'); 
			$message .= '<br /><br />' .  sprintf($lang['Click_resend_manuel'], '<a href="' . sessid('envoi.php?resend=true&amp;id=' . $logdata['log_id']) . '">', '</a>'); 
		}
	}
	else
	{
		$sql = "UPDATE " . LOG_TABLE . " 
			SET log_status = " . STATUS_SENDED . ", 
				log_numdest = $sended 
			WHERE log_id = " . $logdata['log_id']; 
		if( !$db->query($sql) )
		{
			trigger_error('Impossible de mettre  jour la table des logs', ERROR); 
		}
		
		$sql = "UPDATE " . LISTE_TABLE . " 
			SET liste_numlogs = liste_numlogs + 1 
			WHERE liste_id = " . $listdata['liste_id']; 
		if( !$db->query($sql) )
		{
			trigger_error('Impossible de mettre  jour la table des listes', ERROR); 
		}
		
		$message = sprintf($lang['Message']['Success_send'], $sended); 
	}
	
	trigger_error($message, MESSAGE); 
}

?>